// TetrisMgrDll.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "TetrisMgrDll.h"

#include "ITetrisMgr.h"

void* __stdcall TetrisMgrDll_GetTetrisMgr()
{
	return GetTetrisMgr();
}

void __stdcall TetrisMgrDll_ReleaseTetrisMgr(void* handle)
{
	if(!handle){
		return;
	}
	ReleaseTetrisMgr((ITetrisMgr*)handle);
}

int __stdcall TetrisMgrDll_OnInit(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnInit();
}

int __stdcall TetrisMgrDll_OnStart(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnStart();
}

int __stdcall TetrisMgrDll_OnLeft(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnLeft();
}

int __stdcall TetrisMgrDll_OnRight(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnRight();
}

int __stdcall TetrisMgrDll_OnLRotate(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnLRotate();
}

int __stdcall TetrisMgrDll_OnRRotate(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnRRotate();
}

int __stdcall TetrisMgrDll_OnDown(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnDown();
}

int __stdcall TetrisMgrDll_OnFall(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (int)pMgr->OnFall();
}

unsigned int __stdcall TetrisMgrDll_GetFallTimerInterval(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (unsigned int)pMgr->GetFallTimerInterval();
}

unsigned int __stdcall TetrisMgrDll_GetBlockState(void* handle, unsigned int x, unsigned int y)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return (unsigned int)pMgr->GetBlockState(x, y);
}

int __stdcall TetrisMgrDll_IsGameOver(void* handle)
{
	if(!handle){
		return (int)ITetrisMgr::ERR_ARG;
	}

	ITetrisMgr *pMgr = (ITetrisMgr*)handle;
	return pMgr->IsGameOver() ? 1 : 0;
}
