#ifndef TETRISMGRDLL_H
#define TETRISMGRDLL_H

#ifdef TETRISMGRDLL_EXPORTS
#   define DLL_EXPORT __declspec (dllexport)
#else
#   define DLL_EXPORT __declspec (dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

DLL_EXPORT void* __stdcall TetrisMgrDll_GetTetrisMgr();
DLL_EXPORT void  __stdcall TetrisMgrDll_ReleaseTetrisMgr(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnInit(void* handle); 
DLL_EXPORT int   __stdcall TetrisMgrDll_OnStart(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnLeft(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnRight(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnLRotate(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnRRotate(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnDown(void* handle);
DLL_EXPORT int   __stdcall TetrisMgrDll_OnFall(void* handle);
DLL_EXPORT unsigned int __stdcall TetrisMgrDll_GetFallTimerInterval(void* handle);
DLL_EXPORT unsigned int __stdcall TetrisMgrDll_GetBlockState(void* handle, unsigned int x, unsigned int y);
DLL_EXPORT int   __stdcall TetrisMgrDll_IsGameOver(void* handle);

#ifdef __cplusplus
}
#endif

#endif // TETRISMGRDLL_H
